use crate::ffi_util::import;

use super::{
    data::{LogicData, LogicLocationData, LogicNpcData},
    spell::LogicSpellDeck,
};

#[repr(C)]
pub struct LogicBattle {
    unk_gap_1: [u8; 8],   // 0 - 8,
    pub battle_type: i32, // 8
    unk_gap_2: [u8; 32],  // 12 - 44
    pub npc_data: &'static LogicNpcData,
    pub arena_data: &'static LogicData,
}

impl LogicBattle {
    pub fn set_location(&mut self, location: &LogicLocationData, skip_init: bool, listener: usize) {
        import!(logic_battle_set_location(battle: *mut LogicBattle, location: *const LogicLocationData, skip_init: bool, listener: usize) -> () = 0xEE05C + 1);

        logic_battle_set_location(self, location, skip_init, listener);
    }

    pub fn set_spell_decks(&mut self, deck_1: &LogicSpellDeck, deck_2: &LogicSpellDeck) {
        import!(logic_battle_set_spell_decks(battle: *mut LogicBattle, deck_1: *const LogicSpellDeck, deck_2: *const LogicSpellDeck) -> () = 0xEE17C + 1);
        logic_battle_set_spell_decks(self, deck_1, deck_2);
    }
}
