use crate::{allocator, ffi_util::import, sc_string::ScString};

#[repr(C)]
pub struct RC4Encrypter {
    vtable: usize,
    x: i32,
    y: i32,
    key: [u8; 256],
}

impl RC4Encrypter {
    pub fn new(key: &str, nonce: &str) -> *const Self {
        import!(rc4_encrypter_ctor(ptr: *const RC4Encrypter, key: *const ScString, nonce: *const ScString) -> () = 0x15C1B0 + 1);
        let instance = allocator::new::<Self>();
        rc4_encrypter_ctor(instance, ScString::new(key), ScString::new(nonce));
        instance
    }
}
