use crate::{allocator, ffi_util::import};

use super::PiranhaMessage;

#[repr(C)]
pub struct SectorStateMessage {
    pub parent: PiranhaMessage,
}

impl SectorStateMessage {
    pub fn new() -> &'static mut Self {
        import!(sector_state_message_ctor(ptr: *mut SectorStateMessage) -> () = 0x132DA0 + 1);
        let instance = allocator::new::<Self>();
        sector_state_message_ctor(instance);
        unsafe { &mut *instance }
    }
}
