mod account;
mod home;

use account::*;
use home::*;

macro_rules! messages {
    ($($name:ident),*) => {
        pub fn handle_message(
            session: &mut super::PlayerSession,
            message: &crate::network::message::PiranhaMessage,
        ) {
            use crate::network::message::*;

            match (message.vtable.get_message_type)() {
                $(
                    $name::MESSAGE_TYPE => ::paste::paste!([<on_ $name:snake>](
                        session,
                        unsafe { ::std::mem::transmute(message) }
                    )),
                )*
                unhandled => ::tracing::warn!("unhandled message: {unhandled}"),
            }
        }
    };
}

messages! {
    LoginMessage, KeepAliveMessage, GoHomeMessage, EndClientTurnMessage, StartMissionMessage
}
